#ifndef BOHA_ART
#define BOHA_ART

#include "config.h"

#include <memory>

#include <SDL.h>

class Player;
class MainWindow;

/// ɬ貾ۥ饹
class Art {
public:
	/// ĤǶݥ饹ΤǤ
	static std::auto_ptr<Art> create(Player* player, int level,
									 MainWindow* win);

private:
	void commonInit(Player* player, MainWindow* win);

public:
	/// ǽˤ뤳
	virtual void init() =0;
	/// ƥˤ뤳
	void event();
	/// äɤ
	bool isEnd() const;

	virtual ~Art() {}

private:
	virtual void localEvent() {}
	virtual void localEnd() {}

protected:
	void setEndTime(Uint32 time);

protected:
	MainWindow* win_;
	Player* player_;

	Uint32 endTime_;

};

class RedArt1 : public Art {
public:
	virtual void init();

};

class RedArt2 : public Art {
public:
	virtual void init();

};

class RedArt3 : public Art {
public:
	virtual void init();

};

class OrangeArt1 : public Art {
public:
	virtual void init();

private:
	virtual void localEnd();

};

class OrangeArt2 : public Art {
public:
	virtual void init();

private:
	virtual void localEnd();

};

class OrangeArt3 : public Art {
public:
	virtual void init();

private:
	virtual void localEnd();

};

class YellowArt1 : public Art {
public:
	virtual void init();

private:
	virtual void localEvent();

};

class YellowArt2 : public Art {
public:
	virtual void init();

private:
	virtual void localEvent();

};

class YellowArt3 : public Art {
public:
	virtual void init();

private:
	virtual void localEvent();

};

class GreenArt1 : public Art {
public:
	virtual void init();

private:
	virtual void localEnd();

};

class GreenArt2 : public Art {
public:
	virtual void init();

private:
	virtual void localEnd();

};

class GreenArt3 : public Art {
public:
	virtual void init();

private:
	virtual void localEnd();

};

class BlueArt1 : public Art {
public:
	virtual void init();
	virtual void localEvent() {}

};

class BlueArt2 : public Art {
public:
	virtual void init();

};

class BlueArt3 : public Art {
public:
	virtual void init();

};

class PurpleArt1 : public Art {
public:
	virtual void init();

};

class PurpleArt2 : public Art {
public:
	virtual void init();

private:
	virtual void localEnd();

	int firstRank_;

};

class PurpleArt3 : public Art {
public:
	virtual void init();

};

#endif // ! BOHA_ART


