/// BulletML Υѡ
/**
 * c++  RELAX ̵äΤǤޤʬǺ뤳Ȥ
 */

#ifndef BULLETMLPARSER_H_
#define BULLETMLPARSER_H_

#include "bulletmltree.h"

#include <string>
#include <vector>

#include <stdio.h>

class BulletMLParser {
protected:
    typedef std::vector<std::string> MyAttributes;
    typedef MyAttributes::const_iterator MyAttributeIte;

public:
    BulletMLParser();
    virtual ~BulletMLParser();

public:
	void build();
	void build(FILE* fp);
    virtual void parse() =0;
    virtual void parse(FILE* fp) =0;

public:
    /**
     * BulletML ϻ;ĥ꡼¤κäɬפϤʤ
     * ٥뤫餳Τ߼ɤ
     */
    //@{
    BulletMLNode* getBulletRef(int id);
    BulletMLNode* getActionRef(int id);
    BulletMLNode* getFireRef(int id);
    //@}

	const std::vector<BulletMLNode*>& getTopActions() const {
		return topActions_;
	}

	void setHorizontal() { isHorizontal_ = true; }
    bool isHorizontal() const { return isHorizontal_; }

protected:
    BulletMLNode* addContent(const std::string& name);
    void addAttribute(const MyAttributes& attr, BulletMLNode* elem);

protected:
    /// gccΥС֤θߴΤʤΤ
    template <class Char_>
    std::string uc2string(Char_* src, size_t len = std::string::npos);

protected:
    BulletMLNode* bulletml_;

	std::vector<BulletMLNode*> topActions_;

    typedef std::vector<BulletMLNode*> MyMap;
	typedef MyMap BulletMap;
    typedef MyMap ActionMap;
    typedef MyMap FireMap;
    BulletMap bulletMap_;
    ActionMap actionMap_;
    FireMap fireMap_;

    bool isHorizontal_;

protected:
	/// ŪƳ
	void setName(const std::string& name) { name_ = name; }
	std::string name_;
public:
	const std::string& getName() const { return name_; }

};

template <class Char_>
std::string BulletMLParser::uc2string(Char_* src, size_t len) {
    std::string dst;
    size_t i = 0;
    while (i != len && *src != '\0') {
		dst += *src;
		src++;
		i++;
    }
    return dst;
}

#endif // ! BULLETMLPARSER_H_
