/// BulletML ¹Ԥ
/**
 * Ȥ
 * BulletMLRunner ѾƤĤν貾۴ؿ롣
 */

#ifndef BULLETRUNNER_H_
#define BULLETRUNNER_H_

#include "bulletmltree.h"

#include <vector>
#include <boost/smart_ptr.hpp>

class BulletMLParser;
class BulletMLNode;
class BulletMLRunnerImpl;

typedef std::vector<double> BulletMLParameter;

/// BulletMLRunner ã˻Ѥ륯饹
class BulletMLState {
public:
	BulletMLState(BulletMLParser* bulletml,
				  const std::vector<BulletMLNode*>& node,
				  boost::shared_ptr<BulletMLParameter> para)
		: bulletml_(bulletml), node_(node.begin(), node.end()), para_(para) {}

	BulletMLParser* getBulletML() { return bulletml_; }
	const std::vector<BulletMLNode*>& getNode() const { return node_; }
	boost::shared_ptr<BulletMLParameter> getParameter() { return para_; }

private:
	BulletMLParser* bulletml_;
	std::vector<BulletMLNode*> node_;
	boost::shared_ptr<BulletMLParameter> para_;

};

/// BulletML ¹Ԥ륯饹
/**
 * <pre>
 * Ȥ
 *  1. ѾơBullet ºݤư륯饹롣
 *  2. 貾۴ؿƼ롣
 *  3. ɬפʤ顢changeDirection ʤɤΤɬפʲ۴ؿ롣
 *  4. Υ饹Υ֥ȤФơcom_->run(); ʤɤȤ롣
 * </pre>
 */

class BulletMLRunner {
public:
	explicit BulletMLRunner(BulletMLParser* bulletml);
    explicit BulletMLRunner(BulletMLState* state);
    virtual ~BulletMLRunner();

	/// ¹Ԥ
    void run();

public:
	/// ¹ԤλƤ뤫ɤ
	bool isEnd() const;

	std::string getName() const;

public:
	// ----- мʤФʤʤؿλϤޤ -----
	//@{
	/// Ƥγ٤
	/**
	 * @return ٤ñ̤ǡ 0 ǻ׼֤
	 */
	virtual double getBulletDirection() =0;
	/// Ƥ鼫٤
	/**
	 * @return ٤ñ̤ǡ 0 ǻ׼֤
	 */
	virtual double getAimDirection() =0;
	/// Ƥ®٤
	virtual double getBulletSpeed() =0;
	/// ǥեȤ®٤
	virtual double getDefaultSpeed() =0;
	/// 󥯤
	/**
	 * @return 0  1 ޤǤμ¿
	 */
	virtual double getRank() =0;
	/// action ʤƤ
	virtual void createSimpleBullet(double direction, double speed) =0;
	/// action Ƥ
	/**
	 * @param state
	 * Ƥ BulletMLRunner Υ󥹥ȥ饯Ϥȡ
	 * ⤷ϤʤΤǤСdelete ǲʤФʤʤ
	 */
	virtual void createBullet(BulletMLState* state,
							  double direction, double speed) =0;
	/// ƤδȤʤ륿֤ͤ̾ϥե졼
	/**
	 * @return
	 * ऴȤδǥѹƹޤ󤬡
	 * ϵޤ
	 * xml ǡǡwait  term Υ·äƤꤢޤ
	 */
	virtual int getTurn() =0;
	/// 
	virtual void doVanish() =0;
	//@}
	// ----- мʤФʤʤؿν -----

	// ----- ɬפмؿλϤޤ -----
   	//@{
	/// Ƥꤷѹ
	virtual void doChangeDirection(double) {}
	/// Ƥ®٤ꤷͤѹ
	virtual void doChangeSpeed(double) {}
	/// accel Ф륤󥿡ե
	/**
	 * @todo
	 * horizontal, vertical  type ̤Ǥ
	 * ɤ absolute ˤʤäƤޤޤ
	 */
	virtual void doAccelX(double) {}
	/// accel Ф륤󥿡ե
	/**
	 * @todo
	 * horizontal, vertical  type ̤Ǥ
	 * ɤ absolute ˤʤäƤޤޤ
	 */
	virtual void doAccelY(double) {}
	/// Ƥ® X ʬ֤ޤ
	/**
	 * accel ȤϥС饤ɤƲ
 	 */
	virtual double getBulletSpeedX() { return 0; }
	/// Ƥ® Y ʬ֤ޤ
	/**
	 * accel ȤϥС饤ɤƲ
 	 */
	virtual double getBulletSpeedY() { return 0; }
    //@}
	// ----- ɬפмؿν -----

	/// ֤
	/**
	 * ƤΤȤꡢǥեȤǤ std::rand Ѥޤ
	 */
	virtual double getRand() { return (double)std::rand() / RAND_MAX; }

private:
	/// BulletMLRunnerImpl 򥪡С饤ɤ硢⥪С饤ɤ
	virtual BulletMLRunnerImpl* makeImpl(BulletMLState* state);

protected:
	std::vector<BulletMLRunnerImpl*> impl_;

};

#endif // ! BULLETRUNNER_H_

