#include "char.h"
#include "game.h"
#include "conf.h"
#include "win.h"
#include "sprite.h"

#include <cmath>
#include <iostream>

const Point& Charactor::size() const { return graph_->size(); }

void Charactor::wallEvent() {
	if (zako_) {
		const Point& ms = surface_->size();

		if (center_.x > ms.x || center_.x < 0 ||
			center_.y > ms.y || center_.y < 0)
			alive_ = false;
	}

	else {
		static const Point& ms = surface_->size();
		static const Point& cs = graph_->size();
		static const Point upper(ms.x-cs.x, ms.y-cs.y);

		if (pnt_.x > upper.x) {
			pnt_.x = upper.x;
			calcCenter();
		}
		else if (pnt_.x < 0) {
			pnt_.x = 0;
			calcCenter();
		}
		if (pnt_.y > upper.y) {
			pnt_.y = upper.y;
			calcCenter();
		}
		else if (pnt_.y < 0) {
			pnt_.y = 0;
			calcCenter();
		}
	}
}

Charactor::Charactor (const Point& pnt, Window* graph, CharColor col)
	: spd_(Point(0, 0)),
	  alive_(true), surface_(Game::instance()->screen()), col_(col)
{
	if (graph) {
		graph_.reset(new Sprite(graph));
		pnt_ = pnt - halfSize();
		calcCenter();
	}
}

Charactor::~Charactor() {
}

void Charactor::moveValue() {
	pnt_ += spd_ * Game::instance()->spf();
	calcCenter();
}

void Charactor::moveGraphic() const {
	graph_->draw(surface_, pnt_);
	if (zako_) Game::instance()->drawTrace(pnt_, col_);
}

