#ifndef BOHA_CHAR
#define BOHA_CHAR

#include "config.h"
#include "util.h"
#include "charcolor.h"
#include "sprite.h"

#include <memory>

class Player;
class Enemy;
class Shot;
class Window;
class MainWindow;

/**
 * @todo Charactor ηѾĥ꡼㤯㡣
 */

class Charactor {
public:
    // ֥ǥѥå
    virtual void hit (Charactor*) {};
    virtual void hitByPlayer (Player*) {};
    virtual void hitByEnemy (Enemy*) {};
    virtual void hitByShot (Shot*) {};

    virtual bool isHit(const Charactor* bc) const {
		int diffx = std::abs(center_.xi() - bc->center().xi());
		if (diffx > 20) return false;
		int diffy = std::abs(center_.yi() - bc->center().yi());
		if (diffy > 20) return false;
		return Point(diffx, diffy).length() < 20;
	}

    virtual void wallEvent();

    Charactor(const Point& pnt, Window* graph, CharColor col);
    virtual ~Charactor();

    const Point& pnt() const { return pnt_; }
    const Point& spd() const { return spd_; }
    virtual const Point& size() const;
	const Point& halfSize() const { return graph_->halfSize(); }

	virtual void die() { alive_ = false; }
    bool alive() const { return alive_; }

    virtual void move() {
		moveValue();
		moveGraphic();
    }

    const Point& center() const {
		return center_;
    }

	CharColor color() const { return col_; }

	bool isZako() const { return zako_; }

	void setPnt(const Point& pnt) {
		pnt_ = pnt;
		calcCenter();
	}
	void setSpd(const Point& spd) { spd_ = spd; }

protected:
	void calcCenter() {
		center_ = pnt_ + halfSize();
	}

protected:
    virtual void moveValue();
    virtual void moveGraphic () const;

    Point pnt_, spd_;
	Point center_;

	std::auto_ptr<Sprite> graph_;
    bool alive_;

    MainWindow* surface_;

    // ̤ФäΤ
    bool zako_;

	CharColor col_;

};

/**
 * @remarks
 * 塼ƥ󥰤Υ饯μϤMixin߷פɤ롣
 * ɤ ⤷ޤʤե󥰤ɡ
 * ŪˤäȤͤ 󡼡
 */
class Buzzable {
public:
	Buzzable() : buzzed_(false) {}

	bool buzzed() const { return buzzed_; }
	void setBuzzed() { buzzed_ = true; }

private:
	bool buzzed_;

};

#endif // BOHA_CHAR

