#ifndef BOHA_COMMAND
#define BOHA_COMMAND

#include <bulletml/bulletmlrunner.h>

class Enemy;

class EnemyCommand : public BulletMLRunner {
public:
	EnemyCommand(BulletMLParser* state, Enemy* enemy);
	EnemyCommand(BulletMLParser* state, BulletMLNode* node, Enemy* enemy);
	EnemyCommand(BulletMLState* state, Enemy* enemy);

protected:
	virtual double getBulletDirection();
	virtual double getAimDirection();
	virtual double getBulletSpeed();
	virtual double getDefaultSpeed();
	virtual double getRank();
	virtual void createSimpleBullet(double direction, double speed);
	virtual void createBullet(BulletMLState* state,
							  double direction, double speed);
	virtual int getTurn();
	virtual void doVanish();
	virtual void doChangeDirection(double direction);
	virtual void doChangeSpeed(double speed);
	virtual void doAccelX(double speedx);
	virtual void doAccelY(double speedy);
	virtual double getBulletSpeedX();
	virtual double getBulletSpeedY();

private:
	Enemy* enemy_;

};

#endif // ! BOHA_COMMAND

