#ifndef BOHA_CPU
#define BOHA_CPU

#include "util.h"
#include "charcolor.h"
#include "mysdl_padinput.h"

class CpuInput : public MSDL::InputBase {
private:
    typedef std::vector<std::pair<Point, Point> > PosSpd;

public:
    explicit CpuInput(CharColor col)
		: lastTurn_(-1), color_(col), nextArt_(0), vetohack(0) {}

    virtual MSDL::Axis getAxis() const {
		update();
		return axis_;
    }
    virtual bool getButton(int id) const;

private:
    void update() const;
    double dangerPoint(Point mypnt, PosSpd& posspd, int vetohack) const;

private:
    mutable int lastTurn_;
    mutable int prevIndex_;

    mutable MSDL::Axis axis_;
    mutable bool decision_;

	CharColor color_;

	mutable int nextArt_;

        mutable int vetohack;
};

#endif // ! BOHA_CPU
