#include "game.h"
#include "conf.h"

#include <stdexcept>
#include <iostream>

int main(int argc, char* argv[]) {
  Game* game = new Game;

  try {
    Conf* conf = new Conf(argc, argv);

    std::cout << conf->name() << ":\n";

    game->init();

    int ret = 0;
    while (ret == 0) {
		if (!conf->isFastMode()) ret = game->title();
      if (0 == ret) ret = game->start();
      if (0 == ret) game->reinit();
    }

    delete game;

    return 0;
  }
  catch (std::runtime_error re) {
    std::cerr << re.what() << "\n";
    std::cerr << "SDL: " << SDL_GetError() << "\n";
    delete game;
    return 1;
  }
  catch (...) {
    std::cerr << "unknown exception.\n";
    delete game;
    return 1;
  }
}
