#ifndef BOHA_ENEMY
#define BOHA_ENEMY

#include "util.h"
#include "char.h"

#include <vector>

#include <SDL.h>

#include <boost/smart_ptr.hpp>

/* I know nothing about C++ */
#define ENEMY_BEHAVIOR_NUM 2

class EnemyCommand;
class BulletMLParser;

class EnemyBehavior {
public:
    explicit EnemyBehavior(std::istream& is);
    explicit EnemyBehavior(const std::string& filename);

    BulletMLParser* getRandomAction();
    BulletMLParser* getNextAction();
    bool isRandomAction() const {
		return commandType_ == Random;
    }
    bool isListAction() const {
		return commandType_ == List;
    }

	bool isZako() const { return zako_; }

    void init();

private:
    void parseActionFile(std::istream& is);

    typedef std::vector<class BulletMLParser*> Commands;
    Commands commands_;
    Commands::iterator commandIte_;

    bool zako_;
    enum {List, Random} commandType_;
};

/// ŨΥ饹
/**
 * @todo ѡȥʡ̥饹ˤ٤
 */
class Enemy : public Charactor, public Buzzable {
public:
    Enemy (const Point& pnt, Window* graph,
		   EnemyBehavior* behavior, CharColor col);
    Enemy (const Point& pnt, const Point& spd, Window* graph,
		   class BulletMLState* state, CharColor col);
    virtual ~Enemy();

    void huntEvent ();

    virtual void hit (Charactor* bc) { bc->hitByEnemy(this); }
    virtual void hitByPlayer (Player* bc);
    virtual void hitByEnemy (Enemy* bc);
    virtual void hitByShot (Shot* bc);

	void endCommand();

	void setBehavior(EnemyBehavior* eb) { behavior_ = eb; }

private:
	void nextBullet();

	std::auto_ptr<EnemyCommand> com_;
	BulletMLState* state_;
    EnemyBehavior* behavior_;

	/*
	  std::vector<EnemyCommand*> coms_;
	  EnemyBehavior* behavior_;

	  std::vector<BulletMLNode*> acts_;
	  std::vector<BulletMLNode*>::iterator actIte_;
	  BulletML* bulletml_;

	  PolarCoord polar_;
	  std::auto_ptr<LinearFunc<Uint32, double> > changeDir_;
	  std::auto_ptr<LinearFunc<Uint32, double> > changeSpeed_;
	  std::auto_ptr<LinearFunc<Uint32, Point> > accel_;
	*/

	Uint32 waitTime_;

    // ޥɤμºݤ¤ϰѾƤޤ
    friend class EnemyCommand;
};

class EnemyMgr {
public:
    EnemyMgr();

    void init();

    EnemyBehavior* getNormalBehavior();
    EnemyBehavior* getHardBehavior();
    EnemyBehavior* getLevelBehavior(int level);

protected:
    // ŨɤΤȤˤȤʤ
    std::auto_ptr<EnemyBehavior> normalEnemyBehavior_;
    std::auto_ptr<EnemyBehavior> hardEnemyBehavior_;

    /* braindamage */
    std::auto_ptr<EnemyBehavior> ebhack0;
    std::auto_ptr<EnemyBehavior> ebhack1;
    std::auto_ptr<EnemyBehavior> ebhack2;
    std::auto_ptr<EnemyBehavior> ebhack3;
    std::auto_ptr<EnemyBehavior> ebhack4;
    std::auto_ptr<EnemyBehavior> ebhack5;
    std::auto_ptr<EnemyBehavior> ebhack6;
    std::auto_ptr<EnemyBehavior> ebhack7;
    std::auto_ptr<EnemyBehavior> ebhack8;
    std::auto_ptr<EnemyBehavior> ebhack9;
    std::auto_ptr<EnemyBehavior> ebhack10;
};

#endif // ! BOHA_ENEMY
