#include "info.h"
#include "win.h"

#include <SDL.h>

#include <sstream>

Info::Info(Window* win)
	: win_(win),
          blink_white_buzz(0), blink_white_eat(0),
          blink_black_buzz(0), blink_black_eat(0)
{}

void Info::init() {
	drawFormat();
}

void Info::drawFormat() {
}

void Info::noticeEat(int eat, CharColor col) {
	if (col == WHITE) {
		win_->fillRect(Rect(20, 387, 20+eat, 395), col.color());
	}
	else {
		win_->fillRect(Rect(280-eat, 387, 280, 395), col.color());
	}
}

void Info::noticeBuzz(int buzz, CharColor col) {
	if (col == WHITE) {
		win_->fillRect(Rect(20, 372, 20+buzz, 380), col.color());
	}
	else {
		win_->fillRect(Rect(280-buzz, 372, 280, 380), col.color());
	}
}

void Info::noticeChangeEat(int eat, CharColor col) {
	if (col == WHITE) {
		win_->fillRect(Rect(20, 387, 120, 395), Color::GRAY);

                if (eat >= 100)
                {
                  blink_white_eat += 1;
                  if (blink_white_eat > 30)
                    blink_white_eat = 0;
                }
                else
                {
                  blink_white_eat = 0;
                }
                
                if ((blink_white_eat <= 0) || (blink_white_eat > 5))
                  win_->fillRect(Rect(20, 387, 20+eat, 395), col.color());
	}
	else {
		win_->fillRect(Rect(180, 387, 280, 395), Color::GRAY);

                if (eat >= 100)
                {
                  blink_black_eat += 1;
                  if (blink_black_eat > 30)
                    blink_black_eat = 0;
                }
                else
                {
                  blink_black_eat = 0;
                }

                if ((blink_black_eat <= 0) || (blink_black_eat > 5))
                  win_->fillRect(Rect(280-eat, 387, 280, 395), col.color());
	}
}

void Info::noticeChangeBuzz(int buzz, CharColor col) {
	if (col == WHITE) {
		win_->fillRect(Rect(20, 372, 120, 380), Color::GRAY);

                if (buzz >= 100)
                {
                  blink_white_buzz += 1;
                  if (blink_white_buzz > 30)
                    blink_white_buzz = 0;
                }
                else
                {
                  blink_white_buzz = 0;
                }

                if (buzz < 30)
                  win_->fillRect(Rect(20, 378, 20+buzz, 380), col.color());
                else if (buzz < 60)
                  win_->fillRect(Rect(20, 375, 20+buzz, 380), col.color());
                else if ((blink_white_buzz <= 0) || (blink_white_buzz > 5))
                  win_->fillRect(Rect(20, 372, 20+buzz, 380), col.color());
	}
	else {
		win_->fillRect(Rect(180, 372, 280, 380), Color::GRAY);

                if (buzz >= 100)
                {
                  blink_black_buzz += 1;
                  if (blink_black_buzz > 30)
                    blink_black_buzz = 0;
                }
                else
                {
                  blink_black_buzz = 0;
                }

                if (buzz < 30)
                  win_->fillRect(Rect(280-buzz, 378, 280, 380), col.color());
                else if (buzz < 60)
                  win_->fillRect(Rect(280-buzz, 375, 280, 380), col.color());
                else if ((blink_black_buzz <= 0) || (blink_black_buzz > 5))
                  win_->fillRect(Rect(280-buzz, 372, 280, 380), col.color());
	}
}

