/// Ϥʤ
/**
 * ܡɤȥ祤ƥå
 * @todo 򺹤褦ˤ٤
 */

#ifndef BOHA_INPUT
#define BOHA_INPUT

#include <SDL.h>

#include <vector>

/// ϴ쥯饹
class Input {
public:
    typedef enum {NONE, UP, UPRIGHT, RIGHT, DOWNRIGHT,
		  DOWN, DOWNLEFT, LEFT, UPLEFT} Axis_;

    class Axis {
    public:
	Axis() : axis_(NONE) {}
	explicit Axis(int num) {
	    if (num == 0) axis_ = NONE;
	    else if (num == 1) axis_ = UP;
	    else if (num == 2) axis_ = UPRIGHT;
	    else if (num == 3) axis_ = RIGHT;
	    else if (num == 4) axis_ = DOWNRIGHT;
	    else if (num == 5) axis_ = DOWN;
	    else if (num == 6) axis_ = DOWNLEFT;
	    else if (num == 7) axis_ = LEFT;
	    else if (num == 8) axis_ = UPLEFT;
	}
        Axis(Axis_ axis) : axis_(axis) {}
        operator Axis_() const { return axis_; }

    public:
        bool isRight() const;
        bool isLeft() const;
        bool isDown() const { return axis_ == DOWN; }
        bool isUp() const { return axis_ == UP; }

    private:
        Axis_ axis_;
    };

public:
    Input();
    virtual ~Input();

    virtual Axis getAxis() const =0;
    virtual bool getDecision() const =0;
    virtual bool getCancel() const =0;
    virtual bool getAButton() const =0;
    virtual bool getBButton() const =0;
    virtual bool getCButton() const =0;
};

/// ܡ
class KeyInput : public Input {
public:
    virtual Axis getAxis() const;
    virtual bool getDecision() const;
    virtual bool getCancel() const;
    virtual bool getAButton() const;
    virtual bool getBButton() const;
    virtual bool getCButton() const;
};

/// 祤ƥå
class JoystickInput : public Input {
public:
    explicit JoystickInput(SDL_Joystick* joystick);
    virtual ~JoystickInput();

    virtual Axis getAxis() const;
    virtual bool getDecision() const;
    virtual bool getCancel() const;
    virtual bool getAButton() const;
    virtual bool getBButton() const;
    virtual bool getCButton() const;

protected:
    SDL_Joystick* joystick_;
};

/// Ϥξ֤¸륯饹
class InputState : public Input {
public:
    explicit InputState(const Input& input);

    virtual Axis getAxis() const;
    virtual bool getDecision() const;
    virtual bool getCancel() const;
    virtual bool getAButton() const;
    virtual bool getBButton() const;
    virtual bool getCButton() const;

    virtual bool getAny() const;

protected:
    Axis axis_;
    bool decision_;
    bool cancel_;
    bool aButton_;
    bool bButton_;
    bool cButton_;

};

/// Ϸ
class InputMgr : public Input {
public:
    ~InputMgr();

    void setDevice(Input* input);

    virtual Axis getAxis() const;
    virtual bool getDecision() const;
    virtual bool getCancel() const;
    virtual bool getAButton() const;
    virtual bool getBButton() const;
    virtual bool getCButton() const;

    /**
     * @return 󥻥ܥǽλ false
     */
    virtual bool waitDecision() const;
    virtual InputState waitAnyInput() const;

protected:
    std::vector<Input*> inputs_;
};

#endif // ! BOHA_INPUT
