#ifndef MEM_CHECKER_H_
#define MEM_CHECKER_H_

#ifdef MEM_CHECK

#include <iostream>
#include <typeinfo>

template <class T_>
class MemChecker {
public:
	void* operator new(size_t sz) {
		std::cout << typeid(T_).name() << ": new." << std::endl;
		return malloc(sz);
	}
	void operator delete(void* v) {
		if (v != 0) {
			std::cout << typeid(T_).name() << ": delete." << std::endl;
			free(v);
		}
	}
};

#else

class MemChecker {};

#endif

#include <memory>

#endif // ! MEM_CHECKER_H_
