#include "select.h"
#include "win.h"
#include "util.h"
#include "game.h"

int Select::selectMenu() {
	putString("vs CPU", 10, 10, Color::BLACK);
	putString("vs 2P", 10, 12, Color::BLACK);

	int height = 0;
	int heights = 1;

	std::auto_ptr<MSDL::InputState> state;

	while(1) {
		putString(">", 8, 10+2*height, Color::BLACK);

		win_->flip();
		SDL_Delay(100);
		do {
			SDL_PumpEvents();
			state.reset(new MSDL::InputState(*input_));
			Game::instance()->endEv();
			if (Game::instance()->isEnd()) return -1;
			SDL_Delay(50);
		} while (!state->getAny());

		putString(" ", 8, 10+2*height, Color::BLACK);

		if (state->getAxis().isDown() && height != heights) height++;
		if (state->getAxis().isUp() && height != 0) height--;

		if (state->getButton(0)) {
			if (height == 0) vsCpu_ = true;
			else vsCpu_ = false;
			break;
		}
		else if (state->getButton(3)) {
			return -1;
		}

	}

	win_->clear();

	Game::instance()->waitInputRelease();

	return 0;
}

int Select::selectConfig() {
	return 0;
}

int Select::selectInputDevice() {
	return 0;
}

int Select::selectPlayerType() {
	static const int CHARS = 6;

	std::string strs[CHARS] = {
		"Rank", "Obstacle", "Yank", "Guard", "Background", "Partner"
	};
	std::string l1[CHARS] = {
		"Delete all enemy shots.                         ",
		"You can stop the opponent by touching it.       ",
		"Pull your bullets quickly for a very short time.",
		"You have an aura that flips enemy bullet.       ",
		"Dye around you with your color.                 ",
                "Increase the rank of your partners.             "
	};
	std::string l2[CHARS] = {
		"Increase your eatings.                          ",
		"You have an aura that flips your opponent.      ",
		"Pull your bullets slowly for a while.           ",
		"You have an aura that absorps enemy bullet.     ",
		"Mix your color to the whole world.              ",
                "Temporarily maximize the rank of your partners. "
	};
	std::string l3[CHARS] = {
		"Absorb the eatings of your opponent.            ",
		"You have an aura that kills your opponent.      ",
		"Pull your opponent for a while.                 ",
		"You have an aura that flips all bullet.         ",
		"Dye your color to the whole world.              ",
		"Add your partner.                               "
	};
	Color cols[CHARS] = {
		Color::RED, Color::ORANGE, Color::YELLOW, Color::GREEN,
		Color::BLUE, Color::PURPLE
	};
	PlayerType players[CHARS] = {
		PlayerType::RED, PlayerType::ORANGE, PlayerType::YELLOW,
		PlayerType::GREEN, PlayerType::BLUE, PlayerType::PURPLE
	};

	putString("Please select player", 8, 0, Color::WHITE);
	for (int i = 0; i < CHARS; i++) {
		putString(strs[i], 1, i+1, Color::WHITE);
		putString(strs[i], 1, i+11, Color::BLACK);
	}

	int height = 0;
	CharColor chcolor = WHITE;
	int hmerg = 1;

	std::auto_ptr<MSDL::InputState> state;

	while (1) {
		putString(strs[height], 1, height+hmerg, cols[height]);
		putString("LEVEL1", 10, hmerg, chcolor.color());
		putString(l1[height], 10, 1+hmerg, cols[height]);
		putString("LEVEL2", 10, 2+hmerg, chcolor.color());
		putString(l2[height], 10, 3+hmerg, cols[height]);
		putString("LEVEL3", 10, 4+hmerg, chcolor.color());
		putString(l3[height], 10, 5+hmerg, cols[height]);

		win_->flip();
		SDL_Delay(100);
		do {
			SDL_PumpEvents();
			state.reset(new MSDL::InputState(*input_));
			Game::instance()->endEv();
			if (Game::instance()->isEnd()) return -1;
			SDL_Delay(50);
		} while (!state->getAny());

		putString(strs[height], 1, height+hmerg, chcolor.color());
		if (state->getAxis().isDown() && height != CHARS-1) height++;
		if (state->getAxis().isUp() && height != 0) height--;

		if (state->getButton(0)) {
			playerType_[chcolor] = players[height];
			if (chcolor == WHITE) {
				chcolor = BLACK;
				hmerg += 10;
				height = 0;
			}
			else {
				break;
			}
		}
		else if (state->getButton(3)) {
			return -1;
		}
	}

	win_->clear();

	Game::instance()->waitInputRelease();

	return 0;
}

void Select::putString(const std::string& str, int x, int y,
					   const Color& col) {
	win_->clearRect(Rect(x*charWidth_, y*charHeight_,
						 str.size()*charWidth_, charHeight_, true));
	win_->putString(str, Point(x*charWidth_, y*charHeight_), col);
}
