#ifndef BOHA_SELECT
#define BOHA_SELECT

#include "player.h"
#include "charcolor.h"
#include "mysdl_padinput.h"

class Select {
public:
	Select(MainWindow* win, MSDL::Input* input) : win_(win), input_(input) {}

	int selectMenu();
	int selectConfig();
	int selectInputDevice();
	int selectPlayerType();

public:
	PlayerType playerType(CharColor col) const { return playerType_[col]; }
	bool vsCpu() const { return vsCpu_; }

private:
	static const int charWidth_ =8;
	static const int charHeight_ =20;
	void putString(const std::string& str, int x, int y, const Color& col);

private:
	MainWindow* win_;
	MSDL::Input* input_;

private:
	PlayerType playerType_[2];
	bool vsCpu_;

};

#endif // ! BOHA_SELECT
