#ifndef BOHA_SINGLETON
#define BOHA_SINGLETON

#include "util.h"

// 󥰥ȥΥ١
template<class T>
class Singleton {
public:
	static T* instance();
	Singleton();
	virtual ~Singleton() {}

protected:
	static Singleton* instance_;
};

template<class T>
T* Singleton<T>::instance() {
	// ASSERT(instance_, "Singleton is'nt yet.\n");
	return dynamic_cast<T*>(instance_);
}

template<class T>
Singleton<T>* Singleton<T>::instance_ = 0;

template<class T>
Singleton<T>::Singleton() {
	ASSERT(instance_ == 0, "Singleton is made twice.\n");
	instance_ = this;
}

#endif // ! BOHA_SINGLETON
