#include "sprite.h"
#include "util.h"
#include "win.h"
#include "game.h"
#include "builtinfuncs.h"

Sprite::Sprite(Window* bmp)
	: bmp_(bmp), alphaFlag_(SDL_RLEACCEL|SDL_SRCALPHA),
	  blink_(false)
{}

void Sprite::draw(Window* win, const Point& pnt, Uint8 alpha) {
	if (blink_) {
		if ((Game::instance()->ticks() & 127) < 64) {
			return;
		}
	}

	bmp_->setAlpha(alphaFlag_, alpha);
	win->blit(bmp_, pnt);
}

const Point& Sprite::size() const { return bmp_->size(); }

